// Ex-p5-Audio13-File
// 22-11-2016
// Pour p5.js (Processing en JavaScript)
// Utilise: libraries/p5.js
// Utilise: libraries/p5.sound.js
// https://p5js.org/reference/#/p5.SoundFile
// https://p5js.org/reference/#/p5.Amplitude

NomSon = "cemuhi-12s.mp3";
var Son;
var rms = 0;

function preload() {
  Son = loadSound(NomSon);
}

function setup() {
  createCanvas(windowWidth, windowHeight);
  textSize(18);
  DureeSon = Son.duration();
  analyse = new p5.Amplitude(); // create a new Amplitude analyse
  analyse.setInput(Son);
}

function draw() {
  background(255);
  fill(50, 150, 50);
  text('File: ' + NomSon, 20, 20);
  text("Duration: " + int(DureeSon * 10) / 10 + " seconds", 20, 40);
  text("Channels: " + Son.channels(), 20, 60);
  text("SampleRate: " + Son.sampleRate() + " samples / sec", 20, 80);

  text("Time: " + int(Son.currentTime() * 10) / 10 + " seconds", 20, 120);

  if (Son.isPlaying()) rms = int(analyse.getLevel() * 1000);
  text("RMS level: " + rms / 10 + " ", 20, 140);
  rect(150, 126, rms, 14)

  fill(0);
  text("Click or Space: Play / Pause", 150, 170);
}

function mousePressed() {
  if (Son.isPlaying()) Son.pause();
  else Son.loop();
}

function keyPressed() {
  if (keyCode == 32) {
    if (Son.isPlaying()) Son.pause();
    else Son.loop();
  }
}

function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
}